﻿namespace DeepDiveBinomial

module Listing1 =

   // Some naive factorial implementations.  In practice
   // would need to check for negative inputs.

   // Calculate factorial using mutation and a loop
   let FactWithMutation n =
      let mutable result = 1
      for i in 1..n do
         result <- result * i
      result

   // Calculate factorial using recursion
   let rec FactWithRecursion n =
      match n with
      | 0 -> 1
      | _ -> n * FactWithRecursion (n-1)

   // Calculate factorial using reduce
   // (This one would also need a check for 0 input.)
   let FactWithFold n =
      [1..n] |> Seq.reduce (*)

