﻿namespace DeepDiveBinomial

module Listing4 =

   let Fact n =
      match n with
      | _ when n <= 1 -> 1
      | _ -> [1..n] |> Seq.reduce (*)

   open NUnit.Framework
   open FsUnit

   [<NUnit.Framework.TestFixture>]
   type ``Given the Fact function``() =

      [<TestCase(1,1)>]
      [<TestCase(2,2)>]
      [<TestCase(3,6)>]
      [<TestCase(4,24)>]
      [<TestCase(5,120)>]
      [<TestCase(6,720)>]
      [<TestCase(7,5040)>]
      [<TestCase(8,40320)>]
      [<TestCase(9,362880)>]
      [<TestCase(10,3628800)>]
      [<TestCase(11,39916800)>]
      [<TestCase(12,479001600)>]
      // These ones won't even compile - too big for integers
      // [<TestCase(13,6227020800)>]
      // [<TestCase(14,87178291200)>]
      // [<TestCase(15,1307674368000)>]
      member t.``the result is calculated correctly``(n, expected) =
         let actual = Fact n
         actual |> should equal expected